<%
Option Explicit

Function Encrypt(ByVal pStrMessage, ByVal MyKey)

    Dim lBytAsciiAry(255)
    Dim lBytKeyAry(255)
    Dim lLngIndex
    Dim lBytJump
    Dim lBytTemp
    Dim lBytY
    Dim lLngT
    Dim lLngX
    Dim lLngKeyLength

    Dim RC4

    ' Validate data
    If Len(MyKey) = 0 Then Exit Function
    If Len(pStrMessage) = 0 Then Exit Function

    ' transfer repeated key to array
    lLngKeyLength = Len(MyKey)
    For lLngIndex = 0 To 255
        lBytKeyAry(lLngIndex) = Asc(Mid(MyKey, ((lLngIndex) Mod (lLngKeyLength)) + 1, 1))
    Next

    ' Initialize S
    For lLngIndex = 0 To 255
        lBytAsciiAry(lLngIndex) = lLngIndex
    Next

    ' Switch values of S arround based off of index and Key value
    lBytJump = 0
    For lLngIndex = 0 To 255

        ' Figure index to switch
        lBytJump = (lBytJump + lBytAsciiAry(lLngIndex) + lBytKeyAry(lLngIndex)) Mod 256

        ' Do the switch
        lBytTemp = lBytAsciiAry(lLngIndex)
        lBytAsciiAry(lLngIndex) = lBytAsciiAry(lBytJump)
        lBytAsciiAry(lBytJump) = lBytTemp

    Next

    lLngIndex = 0
    lBytJump = 0

    For lLngX = 1 To Len(pStrMessage)
        lLngIndex = (lLngIndex + 1) Mod 256 ' wrap index
        lBytJump = (lBytJump + lBytAsciiAry(lLngIndex)) Mod 256 ' wrap J+S()

        ' Add/Wrap those two
        lLngT = (lBytAsciiAry(lLngIndex) + lBytAsciiAry(lBytJump)) Mod 256

        ' Switcheroo
        lBytTemp = lBytAsciiAry(lLngIndex)
        lBytAsciiAry(lLngIndex) = lBytAsciiAry(lBytJump)
        lBytAsciiAry(lBytJump) = lBytTemp

        lBytY = lBytAsciiAry(lLngT)

        ' Character Encryption ...
        RC4 = RC4 & Chr(Asc(Mid(pStrMessage, lLngX, 1)) Xor lBytY)
    Next

    Encrypt = Encode(RC4)

End Function


Function Decrypt(ByVal pStrMessage, ByVal MyKey)

    Dim lBytAsciiAry(255)
    Dim lBytKeyAry(255)
    Dim lLngIndex
    Dim lBytJump
    Dim lBytTemp
    Dim lBytY
    Dim lLngT
    Dim lLngX
    Dim lLngKeyLength

    'Decode the string
    pStrMessage = Decode(pStrMessage)

    ' Validate data
    If Len(MyKey) = 0 Then Exit Function
    If Len(pStrMessage) = 0 Then Exit Function

    ' transfer repeated key to array
    lLngKeyLength = Len(MyKey)
    For lLngIndex = 0 To 255
        lBytKeyAry(lLngIndex) = Asc(Mid(MyKey, ((lLngIndex) Mod (lLngKeyLength)) + 1, 1))
    Next

    ' Initialize S
    For lLngIndex = 0 To 255
        lBytAsciiAry(lLngIndex) = lLngIndex
    Next

    ' Switch values of S arround based off of index and Key value
    lBytJump = 0

    For lLngIndex = 0 To 255

        ' Figure index to switch
        lBytJump = (lBytJump + lBytAsciiAry(lLngIndex) + lBytKeyAry(lLngIndex)) Mod 256

        ' Do the switch
        lBytTemp = lBytAsciiAry(lLngIndex)
        lBytAsciiAry(lLngIndex) = lBytAsciiAry(lBytJump)
        lBytAsciiAry(lBytJump) = lBytTemp

    Next


    lLngIndex = 0
    lBytJump = 0

    For lLngX = 1 To Len(pStrMessage)
        lLngIndex = (lLngIndex + 1) Mod 256 ' wrap index
        lBytJump = (lBytJump + lBytAsciiAry(lLngIndex)) Mod 256 ' wrap J+S()

        ' Add/Wrap those two
        lLngT = (lBytAsciiAry(lLngIndex) + lBytAsciiAry(lBytJump)) Mod 256

        ' Switcheroo
        lBytTemp = lBytAsciiAry(lLngIndex)
        lBytAsciiAry(lLngIndex) = lBytAsciiAry(lBytJump)
        lBytAsciiAry(lBytJump) = lBytTemp

        lBytY = lBytAsciiAry(lLngT)

        ' Character Encryption ...

        Decrypt = Decrypt & Chr(Asc(Mid(pStrMessage, lLngX, 1)) Xor lBytY)
    Next

End Function

Private Function Decode(ByVal base64String)

    ' Decodes a base-64 encoded string (BSTR type).
    'rfc1521
    '1999 Antonin Foller, PSTRUH Software, http://pstruh.cz
    Const Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
    Dim dataLength, sOut, groupBegin

    'remove white spaces, If any
    base64String = Replace(base64String, vbCrLf, "")
    base64String = Replace(base64String, vbTab, "")
    base64String = Replace(base64String, " ", "")

    'The source must consists from groups with Len of 4 chars
    dataLength = Len(base64String)
    If dataLength Mod 4 <> 0 Then
        Err.Raise 1, "Decode", "Bad Base64 string."
        Exit Function
    End If


    ' Now decode each group:
    For groupBegin = 1 To dataLength Step 4
        Dim numDataBytes, CharCounter, thisChar, thisData, nGroup, pOut
        ' Each data group encodes up To 3 actual bytes.
        numDataBytes = 3
        nGroup = 0

        For CharCounter = 0 To 3
            ' Convert each character into 6 bits of data, And add it To
            ' an integer For temporary storage. If a character is a '=', there
            ' is one fewer data byte. (There can only be a maximum of 2 '=' In
            ' the whole string.)

            thisChar = Mid(base64String, groupBegin + CharCounter, 1)

            If thisChar = "=" Then
                numDataBytes = numDataBytes - 1
                thisData = 0
            Else
                thisData = InStr(Base64, thisChar) - 1
            End If
        
            If thisData = -1 Then
                Err.Raise 2, "Decode", "Bad character In Base64 string."
                Exit Function
            End If

            nGroup = 64 * nGroup + thisData
        Next

        'Hex splits the long To 6 groups with 4 bits
        nGroup = Hex(nGroup)

        'Add leading zeros
        nGroup = String(6 - Len(nGroup), "0") & nGroup

        'Convert the 3 byte hex integer (6 chars) To 3 characters
        pOut = Chr(CByte("&H" & Mid(nGroup, 1, 2))) + _
        Chr(CByte("&H" & Mid(nGroup, 3, 2))) + _
        Chr(CByte("&H" & Mid(nGroup, 5, 2)))

        'add numDataBytes characters To out string
        sOut = sOut & Left(pOut, numDataBytes)
    Next

    Decode = sOut

End Function


Private Function Encode(ByVal inData)
    'rfc1521
    '2001 Antonin Foller, PSTRUH Software, http://pstruh.cz
    Const Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
    Dim cOut, sOut, I

    'For each group of 3 bytes
    For I = 1 To Len(inData) Step 3
        Dim nGroup, pOut, sGroup

        'Create one long from this 3 bytes.
        nGroup = &H10000 * Asc(Mid(inData, I, 1)) + &H100 * MyASC(Mid(inData, I + 1, 1)) + MyASC(Mid(inData, I + 2, 1))

        'Oct splits the long To 8 groups with 3 bits
        nGroup = Oct(nGroup)

        'Add leading zeros
        nGroup = String(8 - Len(nGroup), "0") & nGroup

        'Convert To base64
        pOut = Mid(Base64, CLng("&o" & Mid(nGroup, 1, 2)) + 1, 1) + _
        Mid(Base64, CLng("&o" & Mid(nGroup, 3, 2)) + 1, 1) + _
        Mid(Base64, CLng("&o" & Mid(nGroup, 5, 2)) + 1, 1) + _
        Mid(Base64, CLng("&o" & Mid(nGroup, 7, 2)) + 1, 1)

        'Add the part To OutPut string
        sOut = sOut + pOut

        'Add a new line For Each 76 chars In dest (76*3/4 = 57)
        'If (I + 2) Mod 57 = 0 Then sOut = sOut + vbCrLf
    Next

    Select Case Len(inData) Mod 3
        Case 1: '8 bit final
        sOut = Left(sOut, Len(sOut) - 2) + "=="
        Case 2: '16 bit final
        sOut = Left(sOut, Len(sOut) - 1) + "="
    End Select

    Encode = sOut

    Encode = Replace(Encode, vbCrLf, "")

End Function

Private Function MyASC(ByVal OneChar)

    If OneChar = "" Then
        MyASC = "0"
    Else
        MyASC = Asc(OneChar)
    End If

End Function

Function URLDecode(ByVal encodedstring)
    Dim strIn, strOut, intPos, strLeft
    Dim strRight, intLoop
    strIn = encodedstring
    strOut = ""
    intPos = InStr(strIn, "+")
    Do While intPos
        strLeft = ""
        strRight = ""
        If intPos > 1 Then
            strLeft = Left(strIn, intPos - 1)
        End If
        If intPos < Len(strIn) Then
            strRight = Mid(strIn, intPos + 1)
        End If
        strIn = strLeft & " " & strRight
        intPos = InStr(strIn, "+")
        intLoop = intLoop + 1
    Loop
    intPos = InStr(strIn, "%")
    Do While intPos
        If intPos > 1 Then
            strOut = strOut & Left(strIn, intPos - 1)
        End If
        strOut = strOut & Chr(CInt("&H" & Mid(strIn, intPos + 1, 2)))
        If intPos > (Len(strIn) - 3) Then
            strIn = ""
        Else
            strIn = Mid(strIn, intPos + 3)
        End If
        intPos = InStr(strIn, "%")
    Loop
    URLDecode = strOut & strIn
End Function

%>
